/***************************************************************************
                          klegacyconfig.h  -  description
                             -------------------
    begin                : Sat Jan 26 13:17:25 NZDT 2002
    copyright            : (C) 2002 by Jonathon Sim
    email                : jsim@free.net.nz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef KLEGACYCONFIG_H_
#define KLEGACYCONFIG_H_

#include <kcmodule.h>

class QXEmbed;
class KProcess;
class KShellProcess;
class KWinModule;
class KAboutData;
class QLabel;

 /**A KControl module that embeds other x-based config tools

*/
class KLegacyConfig: public KCModule
{
	Q_OBJECT
public:
	KLegacyConfig(QWidget *parent = 0L, const char *name = 0L);
	virtual ~KLegacyConfig();
	/**KControl calls this to load module settings*/
	void load();
	void save();
	void defaults();
	int buttons();
	QString quickHelp() const;
	const KAboutData* aboutData() ;

public slots:
	void configChanged();
protected slots:
	void slotWindowAdded(WId);
	 /** Handles the closing of the child window */
	void slotChildExited(KProcess *);
protected:	
	KAboutData *mAboutData;
	KWinModule * mKWin;
	QXEmbed * mEmbedWidget;
	bool mStrictTitleMatch;	//If true, title must match exactly, if false, a substring match will do
	QString mChildTitle; 	//The title of the child, used for swallowing
	QString mChildCmdLine;
	KShellProcess * mChildProcess;
	QLabel * mWaitForChildLabel;
};

#endif
